#ifndef _FILE_H_
#include <vector>
#include <string>

// use the standard namespace
#if !defined (GSDL_NAMESPACE_BROKEN)
#if defined(GSDL_USE_OBJECTSPACE)
using namespace ospace::std;
#else
using namespace std;
#endif
#endif

#include "DiskSpace.h"
#include "FilePath.h"

class File : public FilePath
{
private:
  string name;
  unsigned long size;
  vector<File> children;
  bool is_dir;
  bool does_exist;
  bool is_writable;

  void _getDetails();
  void getChildren();
protected:
public:
  File();
  File(string filename);
  void copy(char *destination);
  bool isDirectory();
  bool isWriteable();
  bool exists();
  unsigned long getRawFileSize();
  unsigned long getFileSize();
  // const char *cString();
  unsigned long getDiskSpace(DiskSpace &diskSpace);
  vector<File>::iterator childBegin();
  vector<File>::iterator childEnd();
};

typedef vector<File> FileVector;
#define _FILE_H_
#endif
